#include <stdio.h>
#include <stdlib.h>

int * leggi_pi(char *nfile, int *n) {
    /* apro il file */
    FILE *fp = fopen(nfile, "r");
    if(fp == NULL) {
        fprintf(stderr, "Impossibile aprire %s\n", nfile);
        exit(1);
    }

    /* conto il numero di elementi da leggere */
    *n = 0;
    int v;
    while(fscanf(fp, "%d", &v) == 1) (*n)++;;

    /* alloco dinamicamente il vettore */
    int *res = (int*) malloc((*n) * sizeof(int));

    /* riporto il cursore alla posizione iniziale */
    rewind(fp);

    /* leggo i dati */
    for(int i = 0; i < *n; ++i)
        fscanf(fp, "%d", &res[i]);

    /* chiudo il file */
    fclose(fp);

    /* restituisco un puntatore all'array */
    return res;
}

int main() {
    /* leggo le prime cifre di pi greco */
    int n;
    int *v = leggi_pi("pi.txt", &n);

    /* stampo */
    printf("%d.", v[0]);
    for(int i = 1; i < n; ++i)
        printf("%d", v[i]);
    printf("\n");

    /* dealloco il vettore */
    free(v);
}
